;
;
; This script is by GtaSpider
; It uses the RSA.dll by peethebee (peethebee@gmx.de)
;
;


;Server

;Splash

Global $splash = SplashTextOn("", "Initializing...", 200, 20, -1, -1, 1)

;###############
;Includes
;###############
#include <GUIConstants.au3>

;###############
;Globals
;###############
Global Const $PORT = 6522
Global Const $IP = @IPAddress1
Global $tcp_Accept,$tcp_Listen,$clientIP

;###############
;Plugins & Options
;###############
$plugin_rsa = PluginOpen(@ScriptDir & "\rsa.dll")
If (Not FileExists("C:\Server.privkey")) Or (Not FileExists("C:\Server.pubkey")) Then RSA_GenerateKeys (InputBox("Bitlength", "Key bitlength", "50"), "C:\", "Server")
DllCall("uxtheme.dll", "none", "SetThemeAppProperties", "int", 1);Set GUI theme to old style
#compiler_plugin_funcs = RSA_GenerateKeys, RSA_Encrypt, RSA_Decrypt

;###############
;TCP/IP
;###############
TCPStartup()
$tcp_Listen = TCPListen($IP, $PORT)

;###############
; GUI
;###############
$gui_main = GUICreate("RSA Chat - Server", 418, 369, 193, 115)
GUISetBkColor(0x000000)


$input_send = GUICtrlCreateInput("", 8, 8, 313, 21)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetBkColor(-1, 0x000000)
$button_send = GUICtrlCreateButton("&Send", 328, 8, 72, 20, 1);Style = 1 (0x001 = $BS_DEFPUSHBUTTON)

GUICtrlCreateLabel("Plaintext:", 8, 40, 77, 15)
GUICtrlSetColor(-1, 0x00FF00)
GUICtrlSetBkColor(-1, 0x000000)
$edit_decrypt = GUICtrlCreateEdit("", 8, 56, 193, 257, $ES_MULTILINE+$WS_VSCROLL+$ES_WANTRETURN)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetBkColor(-1, 0x008000)
GUICtrlCreateLabel("Ciphertext:", 208, 40, 77, 15)
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlSetBkColor(-1, 0x000000)
$edit_encrypt = GUICtrlCreateEdit("", 208, 56, 193, 257, $ES_MULTILINE+$WS_VSCROLL+$ES_WANTRETURN)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetBkColor(-1, 0x800000)

$progress_send = GUICtrlCreateProgress(8, 336, 190, 16, -1, BitOR($WS_EX_CLIENTEDGE, $WS_EX_STATICEDGE))
GUICtrlSetColor(-1, 0x00FF00)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlCreateLabel("Sending (encryption):", 8, 320, 101, 15)
GUICtrlSetColor(-1, 0x00FF00)
GUICtrlSetBkColor(-1, 0x000000)

$progress_recv = GUICtrlCreateProgress(208, 336, 190, 16, -1, BitOR($WS_EX_CLIENTEDGE, $WS_EX_STATICEDGE))
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlCreateLabel("Receiving (decryption):", 208, 320, 105, 15)
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlSetBkColor(-1, 0x000000)


_WaitForIncoming()
;~ ControlSetText($splash, "", "Static1", "Wait for Incoming client...")

;~ $tcp_Accept = TCPAccept($tcp_Listen)
;~ While $tcp_Accept = -1
;~ 	$tcp_Accept = TCPAccept($tcp_Listen)
;~ WEnd
;~ ControlSetText($splash, "", "Static1", "Reciving Informations...")
;~ Global $clientIP = SocketToIP($tcp_Accept)

;~ TCPSend($tcp_Accept, FileRead("C:\server.pubkey", FileGetSize("C:\server.pubkey")))
;~ $recv = TCPRecv($tcp_Accept, 2048)
;~ While $recv = ""
;~ 	$recv = TCPRecv($tcp_Accept, 2048)
;~ WEnd
;~ FileDelete("C:\client.pubkey")
;~ FileWriteLine("C:\client.pubkey", $recv)


;~ SplashOff()

GUISetState()
GUICtrlSetState($input_send, $GUI_FOCUS)



;###############
;Main While
;###############

AdlibEnable("_CheckCon", 1000)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
			
		Case $button_send
			$sSend = GUICtrlRead($input_send)
			If $sSend = "" Then
				MsgBox(48, "", "Please fill text in the input bevore you sending")
				ContinueLoop
			EndIf
			GUICtrlSetData($edit_decrypt, @IPAddress1 & ": " & $sSend & @CRLF, 1)
			$sSend = _RSA_Encrypt($sSend)
			
			;MsgBox(0, "Send", $sSend)
			
			TCPSend($tcp_Accept, $sSend)
			If @error Then
				MsgBox(16, "", "Client Exit!")
				Exit
			EndIf
			GUICtrlSetData($edit_encrypt, @IPAddress1 & ": " & $sSend & @CRLF, 1)
			GUICtrlSetData($input_send, "")
	EndSwitch
	$recv = TCPRecv($tcp_Accept, 2048)
	If $recv <> "" Then
		GUICtrlSetData($edit_encrypt, $clientIP & ": " & $recv & @CRLF, 1)
		GUICtrlSetData($edit_decrypt, $clientIP & ": " & _RSA_Decrypt($recv) & @CRLF, 1)
	EndIf
WEnd


;###############
;Functions
;###############


Func _CheckCon()
	TCPSend($tcp_Accept, Chr(2))
	If @error Then
		If MsgBox(52, "", "Client has exit! Wait for new Client?") = 7 Then Exit
		Global $splash = SplashTextOn("","",200,20,-1,-1,1)
		
		_WaitForIncoming()
	EndIf
EndFunc   ;==>_CheckCon


Func _WaitForIncoming()
	ControlSetText($splash, "", "Static1", "Wait for Incoming client...")

	$tcp_Accept = TCPAccept($tcp_Listen)
	While $tcp_Accept = -1
		$tcp_Accept = TCPAccept($tcp_Listen)
	WEnd
	ControlSetText($splash, "", "Static1", "Reciving Informations...")
	Global $clientIP = SocketToIP($tcp_Accept)

	TCPSend($tcp_Accept, FileRead("C:\server.pubkey", FileGetSize("C:\server.pubkey")))
	$recv = TCPRecv($tcp_Accept, 2048)
	While $recv = ""
		$recv = TCPRecv($tcp_Accept, 2048)
	WEnd
	FileDelete("C:\client.pubkey")
	FileWriteLine("C:\client.pubkey", $recv)
	
	SplashOff()
	Return 1
EndFunc   ;==>_WaitForIncoming


Func _RSA_Encrypt($sText, $sKeyFileName = "C:\\Client", $iProgress = "")
	Local $sBuf, $iLen, $sEnc
	If $iProgress = "" Then $iProgress = $progress_send
;~ 	If $sKeyFileName = "" Then $sKeyFileName = @TempDir & "\rsa"
	
	$iLen = StringLen($sText)
	For $i = 1 To $iLen Step 4
		$sBuf &= RSA_Encrypt (StringMid($sText, $i, 4), $sKeyFileName & ".pubkey")
		GUICtrlSetData($iProgress, (100 * $i) / $iLen)
	Next
	GUICtrlSetData($iProgress, 100)
	Return $sBuf
EndFunc   ;==>_RSA_Encrypt

Func _RSA_Decrypt($sEncText, $sKeyFileName = "C:\\Server", $iProgress = "")
	$sEncText = StringReplace($sEncText, Chr(2), "")
	
	Local $sBuf, $iLen, $sDec, $sSs
	If $iProgress = "" Then $iProgress = $progress_recv
;~ 	If $sKeyFileName = "" Then $sKeyFileName = @TempDir & "\rsa"
	
	$iLen = StringLen($sEncText)
	$sSs = StringSplit($sEncText, "#")
	For $i = 1 To $sSs[0]
		$sBuf &= RSA_Decrypt ($sSs[$i] & "#", $sKeyFileName & ".privkey")
		GUICtrlSetData($iProgress, (100 * $i) / $sSs[0])
	Next
	Return $sBuf
EndFunc   ;==>_RSA_Decrypt


Func OnAutoItExit()
	PluginClose($plugin_rsa)
EndFunc   ;==>OnAutoItExit


Func SocketToIP($SHOCKET)
	Local $sockaddr = DllStructCreate("short;ushort;uint;char[8]")

	Local $aRet = DllCall("Ws2_32.dll", "int", "getpeername", "int", $SHOCKET, _
			"ptr", DllStructGetPtr($sockaddr), "int_ptr", DllStructGetSize($sockaddr))
	If Not @error And $aRet[0] = 0 Then
		$aRet = DllCall("Ws2_32.dll", "str", "inet_ntoa", "int", DllStructGetData($sockaddr, 3))
		If Not @error Then $aRet = $aRet[0]
	Else
		$aRet = 0
	EndIf

	$sockaddr = 0

	Return $aRet
EndFunc   ;==>SocketToIP